
function varargout = FSDT_Database_Maker(varargin)

% This function is the control code of Database Maker interface

% Written by Dmitry Tikhomirov
% Institut fuer Geologie, Universitt Bern
% tikhomirov@geo.unibe.ch, tikhomirovdmitry@gmail.com
% 2013-2016
%
% This program is free software; you can redistribute it and/or modify it 
% under a Creative Commons Attribution-NonCommercial-ShareAlike 3.0 
% Unported License (http://creativecommons.org/licenses/by-nc-sa/3.0/)

%FSDT_DATABASE_MAKER M-file for FSDT_Database_Maker.fig
%      FSDT_DATABASE_MAKER, by itself, creates a new FSDT_DATABASE_MAKER or raises the existing
%      singleton*.
%
%      H = FSDT_DATABASE_MAKER returns the handle to a new FSDT_DATABASE_MAKER or the handle to
%      the existing singleton*.
%
%      FSDT_DATABASE_MAKER('Property','Value',...) creates a new FSDT_DATABASE_MAKER using the
%      given property value pairs. Unrecognized properties are passed via
%      varargin to FSDT_Database_Maker_OpeningFcn.  This calling syntax produces a
%      warning when there is an existing singleton*.
%
%      FSDT_DATABASE_MAKER('CALLBACK') and FSDT_DATABASE_MAKER('CALLBACK',hObject,...) call the
%      local function named CALLBACK in FSDT_DATABASE_MAKER.M with the given input
%      arguments.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help FSDT_Database_Maker

% Last Modified by GUIDE v2.5 22-Jun-2014 20:02:23

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @FSDT_Database_Maker_OpeningFcn, ...
                   'gui_OutputFcn',  @FSDT_Database_Maker_OutputFcn, ...
                   'gui_LayoutFcn',  [], ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
   gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

function initialize_Database_Maker(fig_handle, handles, isreset)

% clean parpool if needed
delete(gcp('nocreate'))

handles.t_step = 100;
handles.h_step = 10;
handles.d_step = 1;
handles.hscarp_step = 100;
handles.mesh_unit = 5;
handles.max_coll_lev_corr = 10;
handles.tot_er = 0;
handles.altitude = 0;
handles.latitude = 0;
handles.longitude = 0;
handles.std_ant = 'std';
handles.tp_table = [0 0];
handles.tp_type = 'bars'; 
handles.azimuth = 0;
handles.alpha = 0;
handles.beta = 0;
handles.gamma = 0;
handles.scarp_height = 0;
handles.rho_r = 0;
handles.rho_c = 0;
handles.s_cov = 0;
handles.rho_s = 0;
handles.s_month = 0;
handles.wat_perc_rock = 0;
handles.wat_perc_coll = 0;
handles.andm = 2.3;
handles.lambda_type = 'true';
handles.lambda = 208;
handles.sample_name = 'Sample1';
handles.sample_top = 0;
handles.sample_bot = 0;
handles.sample_thick = 0;
handles.sample_36Clconc = 0;
handles.sample_36Clerr = 0;
handles.sample_ch = zeros(1,23);
handles.coll_ch = zeros(1,23);
handles.sam_data_in = 0;


set(handles.edit1, 'String', handles.azimuth);
set(handles.edit2, 'String', handles.alpha);
set(handles.edit3, 'String', handles.beta);
set(handles.edit4, 'String', handles.gamma);
set(handles.edit5, 'String', handles.scarp_height);
set(handles.edit6, 'String', handles.rho_r);
set(handles.edit7, 'String', handles.rho_c);
set(handles.edit8, 'String', handles.wat_perc_rock);
set(handles.edit9, 'String', handles.wat_perc_coll);
set(handles.edit10, 'String', handles.s_cov);
set(handles.edit11, 'String', handles.rho_s);
set(handles.edit12, 'String', handles.s_month);

set(handles.text25, 'String', 'There is no topographic shielding.');
set(handles.popupmenu1, 'Value', 1)

set(handles.edit13, 'String', handles.latitude);
set(handles.edit14, 'String', handles.altitude);
set(handles.edit15, 'String', handles.longitude);
set(handles.popupmenu2, 'Value', 1)

set(handles.edit16, 'String', handles.andm);
set(handles.edit17, 'String', handles.lambda);
set(handles.popupmenu3, 'Value', 1)

set(handles.edit19, 'String', handles.tot_er);
set(handles.edit21, 'String', handles.max_coll_lev_corr);

set(handles.edit22, 'String', handles.hscarp_step);
set(handles.edit23, 'String', handles.h_step);
set(handles.edit24, 'String', handles.d_step);
set(handles.popupmenu5, 'Value', 4)
set(handles.edit25, 'String', handles.t_step);


set(handles.text52, 'String', 'Please load sample data.');
data = [{'Colluvium' ; 'Sample1'} cell(2,28)];      
set(handles.uitable1, 'Data', data);

% Update handles structure
guidata(handles.figure1, handles);



% --- Executes just before FSDT_Database_Maker is made visible.
function FSDT_Database_Maker_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   unrecognized PropertyName/PropertyValue pairs from the
%            command line (see VARARGIN)

% Choose default command line output for FSDT_Database_Maker
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

initialize_Database_Maker(gcbf, handles, true);


% UIWAIT makes FSDT_Database_Maker wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = FSDT_Database_Maker_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


%------------------Fault scarp parameters panel----------------------------

% Scarp azimuth
function edit1_Callback(hObject, eventdata, handles)

input_val = str2double(get(hObject, 'String'));

if isnan(input_val) || (input_val < 0) || (input_val > 360)
    errordlg('Scarp azimuth must be a number from 0 to 360!','Error');
    input_val = handles.azimuth;
    set(hObject, 'String', input_val);
end


handles.azimuth = input_val;
guidata(hObject,handles)

function edit1_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% Colluvium dip
function edit2_Callback(hObject, eventdata, handles)

input_val = str2double(get(hObject, 'String'));

if isnan(input_val) || (input_val < 0) || (input_val > 90)
    errordlg('Colluvium dip must be a number from 0 to 90!','Error');
    input_val = handles.alpha;
    set(hObject, 'String', input_val);
end

handles.alpha = input_val;
guidata(hObject,handles)

function edit2_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% Scarp dip 
function edit3_Callback(hObject, eventdata, handles)

input_val = str2double(get(hObject, 'String'));

if isnan(input_val) || (input_val < 0) || (input_val > 90)
    errordlg('Scarp dip must be a number from 0 to 90!','Error');
    input_val = handles.beta;
    set(hObject, 'String', input_val);
end

handles.beta = input_val;
guidata(hObject,handles)

function edit3_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% Top surface dip
function edit4_Callback(hObject, eventdata, handles)

input_val = str2double(get(hObject, 'String'));

if isnan(input_val) || (input_val < -90) || (input_val > 90)
    errordlg('Top surface dip must be a number from -90 to 90!','Error');
    input_val = handles.gamma;
    set(hObject, 'String', input_val);
end

handles.gamma = input_val;
guidata(hObject,handles)

function edit4_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% Scarp height
function edit5_Callback(hObject, eventdata, handles)

input_val = str2double(get(hObject, 'String'));

if isnan(input_val) || (input_val < 0) || max(handles.sample_top) > input_val
    errordlg('Scarp height must be a positive number bigger than sample stripe top!','Error');
    input_val = handles.scarp_height;
    set(hObject, 'String', input_val);
end

handles.scarp_height = input_val;
guidata(hObject,handles)

function edit5_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% Rock density
function edit6_Callback(hObject, eventdata, handles)

input_val = str2double(get(hObject, 'String'));

if isnan(input_val) || (input_val < 0)
    errordlg('Rock density must be a positive number!','Error');
    input_val = handles.rho_r;
    set(hObject, 'String', input_val);
end

handles.rho_r = input_val;
guidata(hObject,handles)

function edit6_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% Colluvium density
function edit7_Callback(hObject, eventdata, handles)

input_val = str2double(get(hObject, 'String'));

if isnan(input_val) || (input_val < 0)
    errordlg('Colluvium density must be a positive number!','Error');
    input_val = handles.rho_c;
    set(hObject, 'String', input_val);
end

handles.rho_c = input_val;
guidata(hObject,handles)

function edit7_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% Rock water content
function edit8_Callback(hObject, eventdata, handles)

input_val = str2double(get(hObject, 'String'));

if isnan(input_val) || (input_val < 0) || (input_val > 100)
    errordlg('Rock water content must be a positive number from 0 to 100%!','Error');
    input_val = handles.wat_perc_rock;
    set(hObject, 'String', input_val);
end

handles.wat_perc_rock = input_val;
guidata(hObject,handles)

function edit8_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% Colluvium water content
function edit9_Callback(hObject, eventdata, handles)

input_val = str2double(get(hObject, 'String'));

if isnan(input_val) || (input_val < 0) || (input_val > 100)
    errordlg('Colluvium water content must be a positive number from 0 to 100%!','Error');
    input_val = handles.wat_perc_coll;
    set(hObject, 'String', input_val);
end

handles.wat_perc_coll = input_val;
guidata(hObject,handles)

function edit9_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% Snow cover depth
function edit10_Callback(hObject, eventdata, handles)

input_val = str2double(get(hObject, 'String'));

if isnan(input_val) || (input_val < 0)
    errordlg('Snow cover depth must be a positive number or zero!','Error');
    input_val = handles.s_cov;
    set(hObject, 'String', input_val);
end

handles.s_cov = input_val;
guidata(hObject,handles)

function edit10_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% Snow density
function edit11_Callback(hObject, eventdata, handles)

input_val = str2double(get(hObject, 'String'));

if isnan(input_val) || (input_val < 0)
    errordlg('Snow density must be a positive number!','Error');
    input_val = handles.rho_s;
    set(hObject, 'String', input_val);
end

handles.rho_s = input_val;
guidata(hObject,handles)

function edit11_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% Winter season
function edit12_Callback(hObject, eventdata, handles)

input_val = str2double(get(hObject, 'String'));

if isnan(input_val) || (input_val < 0) || (input_val > 12)
    errordlg('Winter season must be a number from 0 to 12!','Error');
    input_val = handles.s_month;
    set(hObject, 'String', input_val);
end

handles.s_month = input_val;
guidata(hObject,handles)

function edit12_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% Scarp Visual Check
function pushbutton1_Callback(hObject, eventdata, handles)

close(findobj('Type','figure','Name','Scarp_Visual_Check'));
Scarp_Visual_Check(handles.alpha,handles.beta,handles.gamma,handles.s_cov,handles.rho_r,handles.rho_c,handles.rho_s);


%----------------Topographic shielding panel-------------------------------

% Approximation type
function popupmenu1_Callback(hObject, eventdata, handles)

choise = get(hObject,'Value');

switch choise
    case 1
        handles.tp_type = 'bars';
    case 2
        handles.tp_type = 'points';
end

guidata(hObject,handles)

function popupmenu1_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% Load topo-shielding file
function pushbutton2_Callback(hObject, eventdata, handles)

last_topo_mes = get(handles.text25, 'String');
set(handles.text25, 'String', 'Loading...');
close(findobj('Type','figure','Name','TopoVisualCheck'));

[tp_fileName, tp_filePath] = uigetfile({'*.xlsx';'*.xls'});

% If "Cancel" is selected then return
if isequal([tp_fileName, tp_filePath],[0,0])
    set(handles.text25, 'String', last_topo_mes);
    
% Otherwise construct the fullfilename
else
    tp_file = fullfile(tp_filePath, tp_fileName);
    tp_table = xlsread(tp_file);
    
    if find(isnan(tp_table)) ~= 0
        errordlg('Topographic shielding file should consist of numbers only!','Error');
        set(handles.text25, 'String', last_topo_mes);
    elseif size(tp_table,2) ~= 2
        errordlg('Topographic shielding file should have two columns!','Error');
        set(handles.text25, 'String', last_topo_mes);
    else
      set(handles.text25,'String',['Topographic shieldind is loaded from file: ' tp_file]);
      handles.tp_table = tp_table;
    end
end

guidata(hObject,handles)

% Topo Visual Check
function pushbutton3_Callback(hObject, eventdata, handles)

close(findobj('Type','figure','Name','Topo_Visual_Check'));
Topo_Visual_Check(handles.tp_table, handles.tp_type);


%------------------Location panel------------------------------------------

% Latitude
function edit13_Callback(hObject, eventdata, handles)

input_val = str2double(get(hObject, 'String'));

if isnan(input_val) || (input_val < -90) || (input_val > 90)
    errordlg('Latitude must be a number from -90 to 90! Latitude is positive for northern hemisphere and negative for southern.','Error');
    input_val = handles.latitude;
    set(hObject, 'String', input_val);
end

handles.latitude = input_val;
guidata(hObject,handles)

function edit13_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% Altitude
function edit14_Callback(hObject, eventdata, handles)

input_val = str2double(get(hObject, 'String'));

if isnan(input_val) || (input_val < 0)
    errordlg('Altitude must be a positive number or zero!','Error');
    input_val = handles.altitude;
    set(hObject, 'String', input_val);
end

handles.altitude = input_val;
guidata(hObject,handles)

function edit14_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% Longitude
function edit15_Callback(hObject, eventdata, handles)

input_val = str2double(get(hObject, 'String'));

if isnan(input_val) || (input_val < -360) || (input_val > 360)
    errordlg('Longitude must be a number from -360 to 360! Longitude is measured positively to the east and negatively to the west.','Error');
    input_val = handles.longitude;
    set(hObject, 'String', input_val);
end

handles.longitude = input_val;
guidata(hObject,handles)

function edit15_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% Atmosphere type
function popupmenu2_Callback(hObject, eventdata, handles)

choise = get(hObject,'Value');

switch choise
    case 1
        handles.std_ant = 'std';
    case 2
        handles.std_ant = 'ant';
end

guidata(hObject,handles)

function popupmenu2_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%-------------------High-energy neutron parameters-------------------------

% Angular distribution parameter
function edit16_Callback(hObject, eventdata, handles)
input_val = str2double(get(hObject, 'String'));

if isnan(input_val) || (input_val < 0)
    errordlg('Angular distribution parameter of high-energy neutrons must be a positive number!','Error');
    input_val = handles.andm;
    set(hObject, 'String', input_val);
end

handles.andm = input_val;
guidata(hObject,handles)

function edit16_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% Attenuation length
function edit17_Callback(hObject, eventdata, handles)

input_val = str2double(get(hObject, 'String'));

if isnan(input_val) || (input_val < 0)
    errordlg('Attenuation length of high-energy neutrons must be a positive number!','Error');
    input_val = handles.lambda;
    set(hObject, 'String', input_val);
end

handles.lambda = input_val;
guidata(hObject,handles)

function edit17_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% Attenuation length type
function popupmenu3_Callback(hObject, eventdata, handles)

choise = get(hObject,'Value');

switch choise
    case 1
        handles.lambda_type = 'true';
        handles.lambda = 208;
    case 2
        handles.lambda_type = 'apparent';
        handles.lambda = 160;
end
set(handles.edit17, 'String', handles.lambda);
guidata(hObject,handles)

function popupmenu3_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%---------------Fault scarp history panel----------------------------------

% Maximal total erosion
function edit19_Callback(hObject, eventdata, handles)

input_val = str2double(get(hObject, 'String'));

if isnan(input_val) || (input_val < 0)
    errordlg('Maximal total erosion must be a positive number or zero!','Error');
    input_val = handles.tot_er;
    set(hObject, 'String', input_val);
end

handles.tot_er = input_val;
guidata(hObject,handles)

function edit19_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% Reference point error
function edit21_Callback(hObject, eventdata, handles)

input_val = str2double(get(hObject, 'String'));

if isnan(input_val) || (input_val < 0)
    errordlg('Reference point error must be a positive number or zero!','Error');
    input_val = handles.max_coll_lev_corr;
    set(hObject, 'String', input_val);
end
handles.max_coll_lev_corr = input_val;

guidata(hObject,handles)

function edit21_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%-----------------------Database mesh size panel---------------------------

% Scarp slip mesh
function edit22_Callback(hObject, eventdata, handles)

input_val = str2double(get(hObject, 'String'));

if isnan(input_val) || (input_val < 0)
    errordlg('Mesh size of scarp slip must be a positive number!','Error');
    input_val = handles.hscarp_step;
    set(hObject, 'String', input_val);
end

handles.hscarp_step = input_val;
guidata(hObject,handles)

function edit22_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% Sample position along the scarp
function edit23_Callback(hObject, eventdata, handles)

input_val = str2double(get(hObject, 'String'));

if isnan(input_val) || (input_val < 0)
    errordlg('Mesh size of sample position along the scarp must be a positive number!','Error');
    input_val = handles.h_step;
    set(hObject, 'String', input_val);
end

handles.h_step = input_val;
guidata(hObject,handles)

function edit23_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% Sample depth mesh
function edit24_Callback(hObject, eventdata, handles)

input_val = str2double(get(hObject, 'String'));

if isnan(input_val) || (input_val < 0)
    errordlg('Mesh size of sample depth must be a positive number!','Error');
    input_val = handles.d_step;
    set(hObject, 'String', input_val);
end

handles.d_step = input_val;
guidata(hObject,handles)

function edit24_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% Sky hemisphere mesh
function popupmenu5_Callback(hObject, eventdata, handles)

choise = get(hObject,'Value');

switch choise
    case 1
        handles.mesh_unit = 1;
    case 2
        handles.mesh_unit = 2;
    case 3
        handles.mesh_unit = 3;
    case 4
        handles.mesh_unit = 5;
    case 5
        handles.mesh_unit = 6;
end

guidata(hObject,handles)

function popupmenu5_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% Time scale mesh
function edit25_Callback(hObject, eventdata, handles)

input_val = str2double(get(hObject, 'String'));

if isnan(input_val) || (input_val < 0)
    errordlg('Mesh size of time scale must be a positive number!','Error');
    input_val = handles.t_step;
    set(hObject, 'String', input_val);
end

handles.t_step = input_val;
guidata(hObject,handles)

function edit25_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%--------------------Sample data panel-------------------------------------

% Sample data load
function pushbutton4_Callback(hObject, eventdata, handles)

last_sam_mes = get(handles.text52, 'String');
set(handles.text52, 'String', 'Loading...');

[sam_fileName, sam_filePath] = uigetfile({'*.xlsx';'*.xls'});

% If "Cancel" is selected then return
if isequal([sam_fileName, sam_filePath],[0,0])
    set(handles.text52, 'String', last_sam_mes);

    % Otherwise load data
else
    sam_file = fullfile(sam_filePath, sam_fileName);
    [sam_data, sam_names, sam_cell] = xlsread(sam_file);

    sam_cell = sam_cell(:,1:29);
    sam_names(1:2,:) = [];
    sample_name = sam_names(:,1)';
    coll_ch = sam_data(1,6:23);
    sam_data(1,:) = [];
    sample_top = sam_data(:,1)';
    sample_bot = sam_data(:,2)';
    sample_thick = sam_data(:,3)';
    sample_36Clconc = sam_data(:,4)';
    sample_36Clerr = sam_data(:,5)';
    sample_ch = sam_data(:,6:23);
    sample_ch_err = sam_data(:,24:28);
    sample_size = sample_top - sample_bot;
    
    % Check data
    if find(isnan(sam_data)) ~= 0
        errordlg('Sample data must be numbers!','Error');
        set(handles.text52, 'String', last_sam_mes);
    elseif find(isnan(coll_ch)) ~= 0
        errordlg('Colluvium data must be numbers!','Error');
        set(handles.text52, 'String', last_sam_mes);
    elseif find(sample_size < 0) ~= 0
        errordlg('Negative sample size was detected!','Error');
        set(handles.text52, 'String', last_sam_mes);
    elseif find(sample_thick < 0) ~= 0
        errordlg('Negative sample thickness was detected!','Error');
        set(handles.text52, 'String', last_sam_mes);
    elseif find(sample_36Clconc < 0) ~= 0
        errordlg('Negative 36Cl concentration error was detected!','Error');
        set(handles.text52, 'String', last_sam_mes);
    elseif find(sample_36Clerr < 0) ~= 0
        errordlg('Negative 36Cl concentration error was detected.!','Error');
        set(handles.text52, 'String', last_sam_mes);
    elseif find(sample_ch < 0) ~= 0
        errordlg('Negative concentration in sample elemental content was detected.!','Error');
        set(handles.text52, 'String', last_sam_mes);
    elseif find(sample_ch_err < 0) ~= 0
        errordlg('Negative concentration error in sample elemental content was detected.!','Error');
        set(handles.text52, 'String', last_sam_mes);
    elseif find(coll_ch < 0) ~= 0
        errordlg('Negative concentration in colluvium elemental content was detected.!','Error');
        set(handles.text52, 'String', last_sam_mes);
    else
        handles.sam_cell = sam_cell;
        sam_cell(1,:) = [];
        sam_cell(1,1:6) = {'Colluvium' '-', '-', '-', '-', '-'};
        handles.sample_name = sample_name;
        handles.sample_top = sample_top;
        handles.sample_bot = sample_bot;
        handles.sample_thick = sample_thick;
        handles.sample_36Clconc = sample_36Clconc;
        handles.sample_36Clerr = sample_36Clerr;
        handles.sample_ch = sample_ch;
        handles.sample_ch_err = sample_ch_err;
        handles.coll_ch = coll_ch;
        
        set(handles.uitable1, 'Data', sam_cell)
        set(handles.text52,'String',['Sample data are loaded from file: ' sam_file]);
        
        if max(handles.sample_top) > handles.scarp_height
             errordlg('Height of the scarp must be bigger than sample stripe top! Please enter correct hight of the scarp.','Error');
        end
        handles.sam_data_in = 1;
    end
end
guidata(hObject,handles)

%---------------------Control buttons--------------------------------------

% Help button
function pushbutton6_Callback(hObject, eventdata, handles)

close(findobj('Type','figure','Name','Database_Maker_Help'));

fid = fopen( fullfile('Database_Maker_Help.txt') );
str_DB_help = textscan(fid, '%s', 'Delimiter','\n');
str_DB_help = str_DB_help{1};
fclose(fid);

hFig_DB_help = figure('Menubar','none', 'Toolbar','none', 'Name','Database_Maker_Help',...
    'NumberTitle', 'off','Color',[0.941, 0.941, 0.941]);

hEdit_DB_help = uicontrol(hFig_DB_help, 'Style','edit', 'FontSize',9, ...
    'Min',0, 'Max',2, 'HorizontalAlignment','left', ...
    'Units','normalized', 'Position',[0 0 1 1], ...
    'BackgroundColor','white','String',str_DB_help);

% About button
function pushbutton19_Callback(hObject, eventdata, handles)

close(findobj('Type','figure','Name','FSDT_About'));

fid = fopen( fullfile('About.txt') );
str_About = textscan(fid, '%s', 'Delimiter','\n');
str_About = str_About{1};
fclose(fid);

hFig_About  = figure('Menubar','none', 'Toolbar','none', 'Name','FSDT_About',...
    'NumberTitle', 'off','Color',[0.941, 0.941, 0.941],'Units','characters','Position', [50 20 80 18]);

hText_About  = uicontrol(hFig_About , 'Style','text', 'FontSize',9, ...
    'Min',0, 'Max',2, 'HorizontalAlignment','center', ...
    'Units','normalized', 'Position',[0 0 1 1],'String',str_About );

% Reset button
function pushbutton5_Callback(hObject, eventdata, handles)

close all
FSDT_Database_Maker;

% Create&save button
function pushbutton7_Callback(hObject, eventdata, handles)

% Check input data
if handles.sam_data_in == 0
    errordlg('Please load sample data to run FSDT_Database_Maker.','Error');
    return
end

stripe_top = max(handles.sample_top);

problem = 0;
message = {'There are some minor problems with database mesh size:'};

if handles.hscarp_step > (handles.scarp_height - stripe_top)
    problem = problem + 1;
    message = [message; num2str(problem) '. Slip mesh size should be less or equal than distance from the top of sample stripe to the top of the scarp.'];
end

if handles.hscarp_step > (stripe_top - handles.max_coll_lev_corr)
    problem = problem + 1;
    message = [message; num2str(problem) '. Slip mesh size should be less than or equal to lenght of sample stripe above colluvium.'];
end

if handles.h_step > handles.hscarp_step/2
    problem = problem + 1;
    message = [message; num2str(problem) '. Mesh size of sample position on the scarp should be less than mesh size of scarp height.'];
end

if mod(handles.hscarp_step,handles.h_step) ~= 0
    problem = problem + 1;
    message = [message; num2str(problem) '. Mesh size of sample position on the scarp should be a divisor of mesh size of scarp height.'];
end
message = [message; 'You can correct database mesh size manually or it will be corrected automatically.'];
% Ask last questions
if problem > 0
    choice1 = questdlg(message, ...
	'Database mesh size problems', ...
	'Automatic correction','Manual correction','Manual correction');
switch choice1
    case 'Manual correction'
        return
    case 'Automatic correction'
end
end

choice2 = questdlg('You are ready to create fault scarp database. This process can take from several hours upto couple of days. Be ready to keep your computer on for this period. Progress bar will give you estimation of remaining time. Create database?', ...
	'Create database?', ...
	'Yes','No','No');
switch choice2
    case 'No'
        return
    case 'Yes'
end

% Ask for a file name to save result
[FileName,PathName] = uiputfile('*.mat','Save Database As');

% If "Cancel" is selected then return
if isequal([FileName,PathName],[0,0])
   	return
end

% Construct the fullfilename 
FFile = fullfile(PathName,FileName);

% Run the calculation
DB = DBmaker(handles.t_step,800000,handles.h_step,handles.d_step,handles.hscarp_step,handles.mesh_unit,...
             handles.scarp_height,handles.max_coll_lev_corr,handles.tot_er,...
             handles.altitude,handles.latitude,handles.longitude,handles.std_ant,handles.tp_table,handles.tp_type,...
             handles.azimuth,handles.alpha,handles.beta,handles.gamma,handles.scarp_height,handles.rho_r,handles.rho_c,...
             handles.s_cov,handles.rho_s,handles.s_month,...
             handles.sample_name,handles.sample_top,handles.sample_bot,handles.sample_thick,...
             handles.sample_ch,handles.sample_ch_err,handles.coll_ch,handles.wat_perc_rock,handles.wat_perc_coll,...
             handles.sample_36Clconc,handles.sample_36Clerr,...
             handles.andm,handles.lambda,handles.lambda_type);
         
if DB.oppa == 0
    return
end

% Save result
save(FFile,'DB');

% Create and save log file
[~, l_name, ~] = fileparts(FFile);
LogFileName = [l_name '_input_data.txt'];
LogFile = fullfile(PathName,LogFileName);
fid = fopen(LogFile,'wt');
FFile_print = strrep(FFile,'\','/');

fprintf(fid,'INPUT PARAMETER VALUES OF FAULT SCARP DATABASE\n\n');
fprintf(fid,['Fault scarp database file name: ' FileName '\n']);
fprintf(fid,['Database file path: ' FFile_print '\n']);
fprintf(fid,['Created ' datestr(now) '\n\n']);
fprintf(fid,'FAULT SCARP PARAMETERS\n');
fprintf(fid,['Scarp azimuth: ' num2str(handles.azimuth) ' deg\n']);
fprintf(fid,['Colluvium dip: ' num2str(handles.alpha) ' deg\n']);
fprintf(fid,['Scarp dip: ' num2str(handles.beta) ' deg\n']);
fprintf(fid,['Top surface dip: ' num2str(handles.gamma) ' deg\n']);
fprintf(fid,['Scarp height: ' num2str(handles.scarp_height) ' cm\n']);
fprintf(fid,['Scarp rock density: ' num2str(handles.rho_r) ' g/cm3\n']);
fprintf(fid,['Colluvium density: ' num2str(handles.rho_c) ' g/cm3\n']);
fprintf(fid,['Rock water content: ' num2str(handles.wat_perc_rock) ' %%\n']);
fprintf(fid,['Colluvium water content: ' num2str(handles.wat_perc_coll) ' %%\n']);
fprintf(fid,['Snow cover depth: ' num2str(handles.s_cov) ' cm\n']);
fprintf(fid,['Snow density: ' num2str(handles.rho_s) ' g/cm3\n']);
fprintf(fid,['Winter season: ' num2str(handles.s_month) ' month\n\n']);
fprintf(fid,'TOPOGRAPHIC SHIELDING\n');
topo_shield_mes = get(handles.text25, 'String');
topo_shield_mes = strrep(topo_shield_mes,'\','/');
fprintf(fid,[topo_shield_mes '\n']);
if strcmp(topo_shield_mes,'There is no topographic shielding.') == 0 && strcmp(handles.tp_type,'bars') == 1
    fprintf(fid,'Horizon line approximated with bars.\n');
elseif strcmp(topo_shield_mes,'There is no topographic shielding.') == 0 && strcmp(handles.tp_type,'points') == 1
    fprintf(fid,'Horizon line approximated with broken-line.\n');
end
fprintf(fid,'\n');
fprintf(fid,'LOCATION\n');
fprintf(fid,['Latitude: ' num2str(handles.latitude) ' deg\n']);
fprintf(fid,['Longitude: ' num2str(handles.longitude) ' deg\n']);
fprintf(fid,['Altitude: ' num2str(handles.altitude) ' m\n']);
if strcmp(handles.std_ant,'std') == 1
    fprintf(fid,'Standard atmosphere model is chosen.\n\n');
elseif strcmp(handles.std_ant,'ant') == 1
    fprintf(fid,'Antarctic atmosphere model is chosen.\n\n');
end
fprintf(fid,'HIGH-ENERGY NEUTRON PARAMETERS\n');
fprintf(fid,['Angular distribution parameter: m =  ' num2str(handles.andm) '\n']);
if strcmp(handles.lambda_type,'true') == 1
    fprintf(fid,['True particle attenuation length: ' num2str(handles.lambda) ' g/cm2\n\n']);
elseif strcmp(handles.lambda_type,'apparent') == 1
    fprintf(fid,['Apparent attenuation length: ' num2str(handles.lambda) ' g/cm2\n\n']);
end
fprintf(fid,'DATABASE LIMITS\n');
fprintf(fid,['Maximal total erosion: ' num2str(handles.tot_er) ' cm\n']);
fprintf(fid,['Reference point error: ' num2str(handles.max_coll_lev_corr) 'cm\n\n']);
fprintf(fid,'DATABASE MESH SIZE\n');
fprintf(fid,['Slip mesh: ' num2str(handles.hscarp_step) ' cm\n']);
fprintf(fid,['Sample position mesh: ' num2str(handles.h_step) ' cm\n']);
fprintf(fid,['Sample depth mesh: ' num2str(handles.d_step) ' cm\n']);
fprintf(fid,['Sky hemisphere mesh: ' num2str(handles.mesh_unit) ' deg\n']);
fprintf(fid,['Time mesh: ' num2str(handles.t_step) ' yr\n\n']);
fprintf(fid,'SAMPLE DATA\n');
sam_data_mes = get(handles.text52, 'String');
sam_data_mes = strrep(sam_data_mes,'\','/');
fprintf(fid,[sam_data_mes '\n']);

fclose(fid);

% Create a success message and ask what to do 

choice3 = questdlg(['Database was successfully created and saved as:' FFile '   Would you like to create another database or go to FSDT_Simulator.'], ...
	'Done', ...
	'Go to Simulator','Another database','Another database');

switch choice3
    case 'Another database'
        return
    case 'Go to Simulator'
        % Close FSDT_Database_Maker and open Simulator
        close(findobj('Type','figure','Name','Scarp_Visual_Check'));
        close(findobj('Type','figure','Name','Topo_Visual_Check'));
        close(findobj('Type','figure','Name','Database_Maker_Help'));
        FSDT_Simulator;
        close(findobj('Type','figure','Name','FSDT_Database_Maker'));
end
