function out = Topo_Visual_Check(tp_table,tp_type)

% creates a window containing a graph of horizon line approximation

% Written by Dmitry Tikhomirov
% Institut fuer Geologie, Universitaet Bern
% tikhomirov@geo.unibe.ch, tikhomirovdmitry@gmail.com
% 2013-2016
%
% This program is free software; you can redistribute it and/or modify it 
% under a Creative Commons Attribution-NonCommercial-ShareAlike 3.0 
% Unported License (http://creativecommons.org/licenses/by-nc-sa/3.0/)

out = figure('Units','characters',...
             'Position', [50, 20, 90, 20],...
             'Name', 'Topo_Visual_Check',...  
             'NumberTitle', 'off','Color',[0.941, 0.941, 0.941],... 
             'MenuBar', 'none','PaperPositionMode', 'auto');
         
axes('Units', 'characters','Position', [9 3 78 16]);

tp_vector = zeros(360,1);
[ss,tt] = min(tp_table(:,1));
ll = length(tp_table(:,1));
tp_table = circshift(tp_table,[ll-tt+1 0]);
tp_table = [0 tp_table(ll,2); tp_table; 360 tp_table(ll,2)];

if strcmp(tp_type,'bars') == 1
    %bars
    lencum = 0;
    
    for k = 1:ll+1
        len = round(tp_table(k+1,1)) - round(tp_table(k,1));
        tp_vector(lencum+1:lencum + len) = tp_table(k,2);
        lencum = lencum + len;
    end
    area(tp_vector,'FaceColor',[1,0.8,0.6]) 
    alpha(0.5)
    grid on
    axis tight
    set(gca,'XTick',[0 30 60 90 120 150 180 210 240 270 300 330 360])
    xlabel('Azimuth, ')
    ylabel('Inclination, ')
    
elseif strcmp(tp_type,'points') == 1
    %points
    area([tp_table(:,1);360; 0],[tp_table(:,2); 0; 0],'FaceColor',[1,0.8,0.6]);
    alpha(0.5)
    grid on
    axis tight
    set(gca,'XTick',[0 30 60 90 120 150 180 210 240 270 300 330 360])
    xlabel('Azimuth, ')
    ylabel('Inclination, ')
end

end