function cleanXlsSheets(filename)

% Cleans excel file content
% From:
% http://www.mathworks.com/matlabcentral/answers/642-how-do-i-clear-the-contents-of-excel-by-sheet

% Retrieve sheet names 
[typ, sheetNames] = xlsfinfo(filename);

% Open Excel as a COM Automation server
Excel = actxserver('Excel.Application');

% Open Excel workbook
Workbook = Excel.Workbooks.Open(filename);

% Clean the content of the sheets (from the first onwards)
cellfun(@(x) Excel.ActiveWorkBook.Sheets.Item(x).Cells.Clear, sheetNames(1:end));

% Now save/close/quit/delete
Workbook.Save;
Excel.Workbook.Close;
invoke(Excel, 'Quit');
delete(Excel)