function out = colluvium(phi,theta,alpha,beta,d,h,s_cov,rho_r,rho_c,rho_s)

% subfunction to calculate shielding under colluvium
% Institut fuer Geologie, Universität Bern
% tikhomirov@geo.unibe.ch, tikhomirovdmitry@gmail.com
% 2014

d_coll = (d*cos(beta-alpha) - h*sin(beta-alpha))*rho_c + s_cov*rho_s;
d_coll_m = d*rho_c;
d_rock = d*rho_r;

out = d_coll*ugol(phi,theta,alpha) - d_coll_m*ugol(phi,theta,beta) + ...
    d_rock*ugol(phi,theta,beta);

end