function out = cont_mode(data,varargin)

% M = cont_mode(x) finds mode value of a continuous variable grouped into
% optimal number of bins defined by Freedman-Diaconis method (calcnbins.m)
% M = cont_mode(x,n) finds mode value of a continuous variable grouped into
% n bins

if isempty(varargin)
    nbin = calcnbins(data,'fd');
else
    nbin = varargin{1};
end

mindata = min(data);
maxdata = max(data);

if mindata == maxdata
    out = mindata;
else
    stepdata = ((maxdata - mindata)/nbin);
    cent = (mindata+0.5*stepdata):stepdata:(maxdata-0.5*stepdata);

    freq = hist(data,cent);
    [useless1,ind] = max(freq);
    out = cent(ind);
end
end