function out = fit1decay(xdata,ydata,init_lambda)

% fits data with exponrntial decay function:
% f(x) = A*exp(-x/lambda)
% and finds lambda parameter
if length(xdata) < 2
    error('Reduce step along depth')
end

decfit = @(lambda)sum((ydata./ydata(1) - exp(-xdata./lambda)).^2);

[lambda,fval] = fminsearch(decfit, init_lambda,optimset('MaxIter',1e6));

out = [lambda fval];


