function out = get_rand(argin)

% generates random value depending on third column of argin:
% 0 - normal distribution (first column - mean, second column - standard deviation)
% 1 - uniform distribution (first & second columns of 'param' are min & max values)
%
% example argin = [5 1 0; 3 0.5 0; 2 8 1; 0 5 1]
% out = [(5 +- 1 normal) (3 +- 0.5 normal) (2 - 8 uniform) (0 - 5 uniform)]

n = size(argin,1);
out = zeros(1,n);

for i = 1:n
    if argin(i,3) == 0
        if argin(i,2) == 0
            out(i) = argin(i,1);
        else
            out(i) = randn.*argin(i,2) + argin(i,1);
        end
    elseif argin(i,3) == 1
        if argin(i,1) == argin(i,2)
            out(i) = argin(i,1);
        elseif argin(i,1) < argin(i,2)
            out(i) = rand.*(argin(i,2) - argin(i,1)) + argin(i,1);
        elseif argin(i,2) < argin(i,1)
            out(i) = rand.*(argin(i,1) - argin(i,2)) + argin(i,2);
        end
    end
end

end